import { Plugin } from "obsidian";
import { DataFrame, ProjectView } from "obsidian-projects-types";

class MySampleView extends ProjectView {
	dataEl?: HTMLElement;

	getViewType(): string {
		return "my-sample-view";
	}

	getDisplayName(): string {
		return "Sample view";
	}

	getIcon(): string {
		return "apple";
	}

	async onData(frame: DataFrame) {
		if (this.dataEl) {
			this.dataEl.empty();

			this.dataEl.createDiv({ text: JSON.stringify(frame.fields) });
			this.dataEl.createDiv({ text: JSON.stringify(frame.records) });
		}
	}

	async onOpen({ contentEl }) {
		console.log("Opening ", this.getDisplayName());

		contentEl.createEl("h1", { text: "My Sample View" });

		this.dataEl = contentEl.createEl("div");
	}

	async onClose() {
		console.log("Closing ", this.getDisplayName());
	}
}

export default class MyPlugin extends Plugin {
	onRegisterProjectViewV2 = () => new MySampleView();
}
